/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.mandarax.util;

import org.mandarax.kernel.Clause;

/**
 * Iterator for a single clause. The implementation is trivial!
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.0
 */
public class SingleClauseIterator extends AbstractClauseIterator {

	private boolean end = false;
	private Clause clause = null;

	/**
	 * Constructor.
	 * @param a single clause
	 */
	public SingleClauseIterator(Clause c) {
		super();
		clause = c;
	}
	/**
	 * Indicates whether there are more clauses.
	 * @return true if there are more clauses, false otherwise
	 */
	public boolean hasMoreClauses() {
		return !end;
	}
	/**
	 * Get the next clause.
	 * @return the next clause
	 */
	public org.mandarax.kernel.Clause nextClause() {
		if (end) {
			throw new java.util.NoSuchElementException("The single clause set iterator has only one element!");
		}
		else {
			end = true;
			return clause;
		}
	}

}
